import java.util.*;

public class Checkbook<T extends Transaction> implements Collection<T> {
    private ArrayList<Transaction> transactions;
    private final int CHECKBOOK_SIZE = 100;

    private Payee owner;
    private double cashAmount;

    public Checkbook() {
        this.transactions = new ArrayList<>();
    }

    public Checkbook(double cashAmount) {
        this();
        this.cashAmount = cashAmount;
    }

    public Checkbook(Payee owner, double cashAmount) {
        this(cashAmount);
        this.owner = owner;
    }

    @Override
    public int size() {
        return transactions.size();
    }

    @Override
    public boolean isEmpty() {
        return transactions.isEmpty();
    }

    @Override
    public boolean contains(Object t) {
        return transactions.contains(t);
    }

    @Override
    public Iterator<T> iterator() {
        return (Iterator<T>) transactions.iterator();
    }

    @Override
    public Transaction[] toArray() {
        return (Transaction[]) transactions.toArray();
    }

    @Override
    public <T> T[] toArray(T[] a) {
        return transactions.toArray(a);
    }

    @Override
    public boolean add(Transaction transaction) {
        if (size() <= CHECKBOOK_SIZE) { return transactions.add(transaction); }
        else throw new IndexOutOfBoundsException("Check limit exceeded. You need a new checkbook!");
    }

    @Override
    public boolean remove(Object o) {
        return transactions.remove(o);
    }

    @Override
    public boolean containsAll(Collection<?> c) {
        return transactions.containsAll(c);
    }

    @Override
    public boolean addAll(Collection<? extends T> c) {
        if (size() + c.size() <= CHECKBOOK_SIZE) { return transactions.addAll(c); }
        else throw new IndexOutOfBoundsException("You do not have enough checks available in your checkbook.");
    }

    @Override
    public boolean removeAll(Collection<?> c) {
        return transactions.removeAll(c);
    }

    @Override
    public boolean retainAll(Collection<?> c) {
        return transactions.retainAll(c);
    }

    @Override
    public void clear() {
        transactions.clear();
    }

    //blind us with your Java eloquence....

}
