import java.time.LocalDate;
import java.util.concurrent.atomic.AtomicReference;

public class Transaction {
    private final AtomicReference<Integer> id = new AtomicReference<Integer>();
    private final AtomicReference<LocalDate> date = new AtomicReference<LocalDate>();
    private String memo;
    private Payee payee;
    private TransactionType type; // Credit (reduces the checkbook), Debit (increases the checkbook)
    private Double amount;

    public Transaction(String memo, Payee payee, TransactionType type, Double amount) {
        this.type = type;
        this.memo = memo;
        this.payee = payee;
        this.amount = amount;
    }

    public Integer getId() {
        return id.get();
    }

    public LocalDate getDate() {
        return date.get();
    }

    public TransactionType getType() {
        return type;
    }

    public String getMemo() {
        return memo;
    }

    public void setMemo(String memo) {
        this.memo = memo;
    }

    public Payee getPayee() {
        return payee;
    }

    public void setPayee(Payee payee) {
        this.payee = payee;
    }

    public Double getAmount() {
        if (this.type == TransactionType.DEBIT) {
            return amount;
        }
        return (-1.0 * amount);
    }
}
